/*  cfdg-fe, a Linux/GTK+ front-end for the Context Free Design Grammar
    Copyright (C) 2006  Csaba Skrabák

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA */

/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <pango/pango-font.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>

#include "interface.h"
#include "support.h"

int
main (int argc, char *argv[])
{
  GtkWindow *window1;

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "ISO-8859-1");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");
  add_pixmap_directory ("/usr/share/cfdg-fe");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window1 = GTK_WINDOW(create_window1());

  int ifd=-1;
  if(argc>1)ifd=open(argv[1],O_RDONLY);
  struct stat istat;
  if(ifd>=0){
    fstat(ifd,&istat);
    char*filecontent=(char*)malloc(istat.st_size+1);
    read(ifd,filecontent,istat.st_size);
    filecontent[istat.st_size]=0;
    gint len=(gint)istat.st_size;

    close(ifd);

    GtkTextBuffer*buf=gtk_text_view_get_buffer(
      GTK_TEXT_VIEW(lookup_widget(
	GTK_WIDGET(window1),
        "textview1"
      ))
    );

    gtk_text_buffer_set_text(buf,filecontent,len);

    char*title=(char*)malloc(strlen(argv[1])+16);
    sprintf(title,"Context Free - %s",argv[1]);
    gtk_window_set_title(window1,title);
    gtk_text_buffer_set_modified(buf,FALSE);

    free(filecontent);
  }

  PangoFontDescription*font_desc=pango_font_description_from_string("Monospace 9");
  gtk_widget_modify_font(lookup_widget(GTK_WIDGET(window1),"seedentry"),font_desc);
  gtk_widget_modify_font(lookup_widget(GTK_WIDGET(window1),"textview1"),font_desc);
  gtk_widget_modify_font(lookup_widget(GTK_WIDGET(window1),"textview2"),font_desc);
  pango_font_description_free(font_desc);

  gtk_widget_show(GTK_WIDGET(window1));
  gtk_main ();
  return 0;
}

